function flags_load(customlevel)
	gamestate = "flags"
	level=customlevel
	releasemouse()
	scrollflagmenu=0
	flagselected=1
	xselected=0
	multiplier=1
end
function flags_update(dt)
	scrollflagmenu=scrollflagmenu*.9+(screenheight/2-(flagselected-1)*10*scale)*.1
	multiplier= flagslist[flagselected].step or 1
	if love.keyboard.isDown("lshift","rshift") then
		multiplier=multiplier*16
	end
end
function flags_draw()
	love.graphics.setColor(level.flags["background color"])
	--I wont fuck up the background color
	love.graphics.rectangle("fill",0,0,screenwidth,screenheight)
	love.graphics.setColor(255,255,255)
	love.graphics.push()
		love.graphics.translate(unpack(scroll))
		love.graphics.scale(zoom)
		drawcustomlevel(level,{-scroll[1],-scroll[2],screenwidth,screenheight})
	love.graphics.pop()

	love.graphics.setColor(0,0,0,192)
	love.graphics.rectangle("fill",0,0,screenwidth,screenheight)
	love.graphics.setColor(255,255,255)
	love.graphics.setFont(bigfont)
	love.graphics.print("flags",screenwidth/2-5*6*scale,4*scale,0,2*scale)
	love.graphics.setFont(pacmanfont)
	love.graphics.push()
		love.graphics.translate(0,scrollflagmenu)
		for i,v in ipairs(flagslist) do
			love.graphics.setColor(127,127,127)
			if i==flagselected then
				love.graphics.setColor(255,255,255)
			end
			love.graphics.print(v.name,2*8*scale,(i-1)*10*scale,0,scale)
			if v.type=="color" then
				-- love.graphics.print(tostring(level.flags[v.name]),screenwidth/2+2*8*scale,(i-1)*10*scale,0,scale)
				love.graphics.print("[   ,   ,   ]",screenwidth/2+2*8*scale,(i-1)*10*scale,0,scale)
				love.graphics.setColor(255,0,0)
				if xselected==1 and i==flagselected then
					love.graphics.rectangle("fill",screenwidth/2+3*8*scale,(i-1)*10*scale,3*8*scale,8*scale)
					love.graphics.setColor(255,255,255)
				end
				love.graphics.print(tostring(level.flags[v.name][1]),screenwidth/2+3*8*scale,(i-1)*10*scale,0,scale)
				love.graphics.setColor(0,255,0)
				if xselected==2 and i==flagselected then
					love.graphics.rectangle("fill",screenwidth/2+7*8*scale,(i-1)*10*scale,3*8*scale,8*scale)
					love.graphics.setColor(255,255,255)
				end
				love.graphics.print(tostring(level.flags[v.name][2]),screenwidth/2+7*8*scale,(i-1)*10*scale,0,scale)
				love.graphics.setColor(0,0,255)
				if xselected==3 and i==flagselected then
					love.graphics.rectangle("fill",screenwidth/2+11*8*scale,(i-1)*10*scale,3*8*scale,8*scale)
					love.graphics.setColor(255,255,255)
				end
				love.graphics.print(tostring(level.flags[v.name][3]),screenwidth/2+11*8*scale,(i-1)*10*scale,0,scale)

				love.graphics.setColor(255,255,255)
				love.graphics.rectangle("fill",screenwidth/2+(15*8-1)*scale,((i-1)*10-1)*scale,10*scale,10*scale)
				love.graphics.setColor(level.flags[v.name])
				love.graphics.rectangle("fill",screenwidth/2+15*8*scale,(i-1)*10*scale,8*scale,8*scale)
				love.graphics.setColor(255,255,255)
			else
				local str = tostring(level.flags[v.name])
				if v.type=="number" and (not v.min or v.min~=level.flags[v.name])then
					str="<"..str
				else
					str=" "..str
				end
				if v.type=="number" and (not v.max or v.max~=level.flags[v.name])then
					str=str..">"
				end
				love.graphics.print(str,screenwidth/2+2*8*scale,(i-1)*10*scale,0,scale)
			end
		end
	love.graphics.pop()
	love.graphics.setColor(255,255,255,127)
	if flagslist[flagselected].type=="boolean" then
		love.graphics.print("R set to "..tostring(not level.flags[flagslist[flagselected].name]),4*scale,screenheight-12*scale,0,scale)
	elseif flagslist[flagselected].type=="color" then
		if xselected==0 then
			love.graphics.print("< > edit color",4*scale,screenheight-12*scale,0,scale)
		else
			love.graphics.print("< > edit color   V decrease\nA increase   S speed up",4*scale,screenheight-(4+8+4+8)*scale,0,scale)
		end
	elseif flagslist[flagselected].type=="number" then
		love.graphics.print("< decrease   > increase   S speed up",4*scale,screenheight-12*scale,0,scale)
	end
	love.graphics.setColor(255,255,255)
end
function flags_keypressed(key)
	if key == "escape" then
		editor_load(level,scroll)
		gamestatemovetimer=0
	elseif key=="return" then
		if flagslist[flagselected].type=="boolean" then
			level.flags[flagslist[flagselected].name]=not level.flags[flagslist[flagselected].name]
		end
	elseif key=="down" then
		if flagslist[flagselected].type~="color" or xselected==0 then
			flagselected=(flagselected%#flagslist)+1
			xselected=0
		elseif flagslist[flagselected].type=="color" then
			if love.keyboard.isDown("lshift","rshift") then
				level.flags[flagslist[flagselected].name][xselected]=math.max(0,level.flags[flagslist[flagselected].name][xselected]-16)
			else
				level.flags[flagslist[flagselected].name][xselected]=math.max(0,level.flags[flagslist[flagselected].name][xselected]-1)
			end
		end
	elseif key=="up" then
		if flagslist[flagselected].type~="color" or xselected==0 then
			flagselected=((flagselected-2)%#flagslist)+1
			xselected=0
		elseif flagslist[flagselected].type=="color" then
			if love.keyboard.isDown("lshift","rshift") then
				level.flags[flagslist[flagselected].name][xselected]=math.min(255,level.flags[flagslist[flagselected].name][xselected]+16)
			else
				level.flags[flagslist[flagselected].name][xselected]=math.min(255,level.flags[flagslist[flagselected].name][xselected]+1)
			end
		end
	elseif key=="left" then
		if flagslist[flagselected].type=="number" then
			level.flags[flagslist[flagselected].name]=level.flags[flagslist[flagselected].name]-multiplier
			if flagslist[flagselected].min then
				level.flags[flagslist[flagselected].name]=math.max(level.flags[flagslist[flagselected].name],flagslist[flagselected].min)
			end
		elseif flagslist[flagselected].type=="color" then
			xselected=(xselected-1)%4
		end
	elseif key=="right" then
		if flagslist[flagselected].type=="number" then
			level.flags[flagslist[flagselected].name]=level.flags[flagslist[flagselected].name]+multiplier
			if flagslist[flagselected].max then
				level.flags[flagslist[flagselected].name]=math.min(level.flags[flagslist[flagselected].name],flagslist[flagselected].max)
			end
		elseif flagslist[flagselected].type=="color" then
			xselected=(xselected+1)%4
		end
	end
end
function flags_mousepressed(x,y,button)
	if button=="l" then
		flags_keypressed("return")
	elseif button=="wd" then
		flags_keypressed("down")
	elseif button=="wu" then
		flags_keypressed("up")
	end
end