function string:split(delimiter) --Not by me
	local result = {}
	local from  = 1
	local delim_from, delim_to = string.find( self, delimiter, from  )
	while delim_from do
		table.insert( result, string.sub( self, from , delim_from-1 ) )
		from = delim_to + 1
		delim_from, delim_to = string.find( self, delimiter, from  )
	end
	table.insert( result, string.sub( self, from  ) )
	return result
end
function print_r (t, indent) --Not by me
	local indent=indent or ''
	for key,value in pairs(t) do
		io.write(indent,'[',tostring(key),']') 
		if type(value)=="table" then io.write(':\n') print_r(value,indent..'\t')
		else io.write(' = ',tostring(value),'\n') end
	end
end
function addzeros(s, i)
	for j = string.len(s)+1, i do
		s = "0" .. s
	end
	return s
end
function deepcopy(orig)
	local orig_type = type(orig)
	local copy
	if orig_type == 'table' then
		copy = {}
		for orig_key, orig_value in next, orig, nil do
			copy[deepcopy(orig_key)] = deepcopy(orig_value)
		end
		setmetatable(copy, deepcopy(getmetatable(orig)))
	else -- number, string, boolean, etc
		copy = orig
	end
	return copy
end
function aabb(a,b)
	return a[1]<=b[1]+b[3] and a[2]<=b[2]+b[4] and b[1]<=a[1]+a[3] and b[2]<=a[2]+a[4]
end
function lockmouse()
	if controlmethod == "mouse" then
		love.mouse.setVisible(false)
		love.mouse.setGrab(true)
		love.mouse.setPosition(screenwidth/2, screenheight/2)
	elseif controlmethod == "mouse direction" then
		love.mouse.setPosition(screenwidth/2, screenheight/4)
		love.mouse.setGrab(true)
		love.mouse.setVisible(true)
	else
		love.mouse.setGrab(false)
		love.mouse.setVisible(true)
	end
end
function releasemouse()
	love.mouse.setGrab(false)
	love.mouse.setVisible(true)
end
function lerp(a,b,i)
	return a+(b-a)*i
end
--Found that in mari0
function openSaveFolder(subfolder) --By Slime
	local path = love.filesystem.getSaveDirectory()
	path = subfolder and path.."/"..subfolder or path
	
	local cmdstr
	local successval = 0
	
	if os.getenv("WINDIR") then -- lolwindows
		--cmdstr = "Explorer /root,%s"
		if path:match("LOVE") then --hardcoded to fix ISO characters in usernames and made sure release mode doesn't mess anything up -saso
			cmdstr = "Explorer %%appdata%%\\LOVE\\not_pacman"
		else
			cmdstr = "Explorer %%appdata%%\\not_pacman"
		end
		path = path:gsub("/", "\\")
		successval = 1
	elseif os.getenv("HOME") then
		if path:match("/Library/Application Support") then -- OSX
			cmdstr = "open \"%s\""
		else -- linux?
			cmdstr = "xdg-open \"%s\""
		end
	end
	
	-- returns true if successfully opened folder
	return cmdstr and os.execute(cmdstr:format(path)) == successval
end