function editwall_load(customlevel,wall)
	gamestate = "editwall"
	wallid=wall--globalising the variable
	level=customlevel
	releasemouse()
	margin=40*scale
	viewscaling=zoom
	viewx=scroll[1]-screenwidth/2
	viewy=scroll[2]-(margin+(screenheight-margin)/2)
	wallprops={"x","y","w","h","dynamic"}
	selectedprop=1
	multiplicator=1
end
function editwall_update(dt)
	viewscaling=viewscaling*.9+(math.min(math.abs(screenwidth/(level.walls[wallid][3]*scale)),
			math.abs((screenheight-margin)/(level.walls[wallid][4]*scale))))/1.5*.1
	viewx=viewx*.9+(-(level.walls[wallid][1]+level.walls[wallid][3]/2)*scale)*.1
	viewy=viewy*.9+(-(level.walls[wallid][2]+level.walls[wallid][4]/2)*scale)*.1
	multiplicator=love.keyboard.isDown('lshift','rshift') and 16 or 1
end
function editwall_draw()
	love.graphics.setColor(level.flags["background color"])
	--I wont fuck up the background color
	love.graphics.rectangle("fill",0,0,screenwidth,screenheight)
	love.graphics.setColor(255,255,255)

	love.graphics.push()
		love.graphics.translate(screenwidth/2,margin+(screenheight-margin)/2)
		love.graphics.scale(viewscaling)
		love.graphics.translate(viewx,viewy)
		love.graphics.setColor(255,255,255)
		drawcustomlevel(level)
		love.graphics.setColor(255,255,255,192)
		love.graphics.rectangle("fill",level.walls[wallid][1]*scale,level.walls[wallid][2]*scale-level.walls[wallid][4]*scale,scale,level.walls[wallid][4]*scale*3)--left
		love.graphics.rectangle("fill",level.walls[wallid][1]*scale+level.walls[wallid][3]*scale-scale,level.walls[wallid][2]*scale-level.walls[wallid][4]*scale,scale,level.walls[wallid][4]*scale*3)--right
		love.graphics.rectangle("fill",level.walls[wallid][1]*scale-level.walls[wallid][3]*scale,level.walls[wallid][2]*scale+level.walls[wallid][4]*scale-scale,level.walls[wallid][3]*scale*3,scale)--bottom
		love.graphics.rectangle("fill",level.walls[wallid][1]*scale-level.walls[wallid][3]*scale,level.walls[wallid][2]*scale,level.walls[wallid][3]*scale*3,scale)--top
	love.graphics.pop()

	love.graphics.setColor(0,0,0,192)
	love.graphics.rectangle("fill",0,0,screenwidth,margin)
	love.graphics.setColor(255,255,255)
	love.graphics.rectangle("fill",0,margin,screenwidth,scale)
	love.graphics.setFont(bigfont)
	love.graphics.print("edit wall",screenwidth-2*9*6*scale,4*scale,0,2*scale)
	love.graphics.setFont(pacmanfont)
	love.graphics.print("id:"..wallid.."  next-previous",4*scale,4*scale,0,scale)
	love.graphics.print("delete",4*scale,14*scale,0,scale)
	love.graphics.setColor(252, 116, 96)
	love.graphics.print("   "..wallid.."  n    p",4*scale,4*scale,0,scale)
	love.graphics.print("d",4*scale,14*scale,0,scale)
	love.graphics.setColor(255,255,255)
	for i,v in ipairs(wallprops) do
		local text = v..":"
		if type(level.walls[wallid][i])=="boolean" then
			text = text..(level.walls[wallid][i] and "true" or "false")
		else
			text = text..level.walls[wallid][i]
		end
		love.graphics.print(text,
			(8*10*(i-1)+4+10)*scale,
			(20+4)*scale,0,scale)
		if i==selectedprop then
			love.graphics.setColor(252, 116, 96)
			love.graphics.print(">",(8*10*(i-1)+4)*scale,(20+4)*scale,0,scale)
			love.graphics.print("<",(8*10*(i-1)+4+10+8*tostring(text):len())*scale,(20+4)*scale,0,scale)
			love.graphics.setColor(255,255,255)
		end
	end
	love.graphics.setColor(255,255,255)
end
function editwall_keypressed(key)
	if key == "escape" then
		editor_load(level,scroll)
		gamestatemovetimer=0
	elseif key == "right" then
		selectedprop=selectedprop%#wallprops+1
	elseif key == "left" then
		selectedprop=(selectedprop-2)%#wallprops+1
	elseif key == "up" then
		if type(level.walls[wallid][selectedprop])=="number" then
			level.walls[wallid][selectedprop]=level.walls[wallid][selectedprop]-multiplicator
		end
	elseif key == "down" then
		if type(level.walls[wallid][selectedprop])=="number" then
			level.walls[wallid][selectedprop]=level.walls[wallid][selectedprop]+multiplicator
		end
	elseif key == "return" then
		if type(level.walls[wallid][selectedprop])=="boolean" then
			level.walls[wallid][selectedprop]=not level.walls[wallid][selectedprop]
		end
	elseif key == "n" then
		wallid=wallid%#level.walls+1
	elseif key == "p" then
		wallid=(wallid-2)%#level.walls+1
	elseif key == "d" then
		table.remove(level.walls,wallid)
		editor_load(level,scroll)
		gamestatemovetimer=0
	end
end
function editwall_mousepressed(x,y,button)
	if button=="l" then
		editwall_keypressed("return")
	elseif button=="wd" then
		editwall_keypressed("right")
	elseif button=="wu" then
		editwall_keypressed("left")
	elseif button=="r" then
		editwall_keypressed("escape")
	end
end