function drawstyledrect(x,y,w,h)
	if w<0 then
		x=x+w
		w=-w
	end
	if h<0 then
		y=y+h
		h=-h
	end
	love.graphics.rectangle("fill",x+2*scale,y,w-4*scale,scale)
	love.graphics.rectangle("fill",x+2*scale,y+h-scale,w-4*scale,scale)
	love.graphics.rectangle("fill",x,y+2*scale,scale,h-4*scale)
	love.graphics.rectangle("fill",x+w-scale,y+2*scale,scale,h-4*scale)
	--Dots
	love.graphics.rectangle("fill",x+scale,y+h-scale*2,scale,scale)
	love.graphics.rectangle("fill",x+scale,y+scale,scale,scale)
	love.graphics.rectangle("fill",x+w-scale*2,y+h-scale*2,scale,scale)
	love.graphics.rectangle("fill",x+w-scale*2,y+scale,scale,scale)
end
function fillstyledrect(x,y,w,h)
	if w<0 then
		x=x+w
		w=-w
	end
	if h<0 then
		y=y+h
		h=-h
	end
	love.graphics.rectangle("fill",x+2*scale,y,w-4*scale,h)
	love.graphics.rectangle("fill",x+scale,y+scale,w-2*scale,h-2*scale)
	love.graphics.rectangle("fill",x,y+2*scale,w,h-4*scale)
end
function drawgui()
	--pac lives
	love.graphics.setColor(255,255,50)
	if compactview or (level and level.flags["force tiny gui"]) then
		love.graphics.arc("fill",9*scale, 9*scale,6.5*scale,math.pi*.25,math.pi*1.75)
		if lives>1 then
			love.graphics.print("x"..lives,(9+6.5)*scale, 9*scale,0,scale)
		end
	else
		for i = 1, lives do--160-136=24---125+98=223
			love.graphics.arc("fill",24*scale, screenheight-27*scale - (i-1)*17*scale,6.5*scale,math.pi*.25,math.pi*1.75)
		end
	end
	love.graphics.setColor(255,255,255)
	
	--score
		
	score = math.floor(gametime*10)/10
	if score == math.floor(score) then
		score = score .. ".0"
	end
	if compactview or (level and level.flags["force tiny gui"]) then
		love.graphics.draw(clockimg,5*scale, 17*scale,0,scale)
		love.graphics.print(score,13*scale, 17*scale,0,scale)
	else
		-- love.graphics.draw(gamescoreimg, 9*scale, 18*scale, 0, scale, scale)
		love.graphics.setFont(bigfont)
		love.graphics.setColor(255,171,254)
		love.graphics.print("game",12*scale, 18*scale, 0, scale)
		love.graphics.print("time",13*scale, 27*scale, 0, scale)
		love.graphics.setFont(pacmanfont)
		love.graphics.setColor(255,255,255)
		for i = 1, 5 do
			if string.len(tostring(score)) >= 6 - i then
				love.graphics.print(string.sub(tostring(score), i-(5-string.len(tostring(score))), i-(5-string.len(tostring(score)))), 19*scale, 31*scale+9*i*scale, 0, scale)
			else
				love.graphics.print("0", 19*scale, 31*scale+9*i*scale, 0, scale)
			end
		end
	end
	--pellets
	if compactview or (level and level.flags["force tiny gui"]) then
		love.graphics.setColor(level and level.flags["pellets color"] or {255,255,0})
		love.graphics.rectangle("fill",2*scale,28*scale,4*scale,4*scale)
		love.graphics.setColor(255,255,255)
		love.graphics.print(tostring(eatored).."/"..(totalpelletnumber or 244),8*scale,26*scale,0,scale)
	else
		love.graphics.setColor(level and level.flags["pellets color"] or {255,255,0})
		for i=1,math.floor(eatored/100) do
			love.graphics.rectangle("fill",
				(9+((i-1)%6)*5)*scale,
				screenheight-(50+17*(level and level.flags["lifes"] or 3))*scale-8-(10*3/2+5*math.floor((i-1)/6))*scale,
				4*scale,4*scale)
		end
		for i=0,(eatored%100)-1 do
			love.graphics.rectangle("fill",
				(9+(i%10)*3)*scale,
				screenheight-(50+17*(level and level.flags["lifes"] or 3)-1)*scale-(10*3/2-3*math.floor(i/10))*scale,
				2*scale,2*scale)
		end
		love.graphics.setColor(255,255,255)
	end
end