function pause_load()
	pausedgamestate=gamestate
	gamestate="pause"
	love.audio.pause()
	releasemouse()
end
function pause_draw()
	love.graphics.push()
	if _G[pausedgamestate.."_draw"]then
		_G[pausedgamestate.."_draw"]()
	end
	love.graphics.pop()

	love.graphics.setColor(0,0,0,127)
	love.graphics.rectangle("fill",0,screenheight-24*scale,screenwidth,24*scale)
	love.graphics.setColor(255,255,255)
	love.graphics.rectangle("fill",0,screenheight-25*scale,screenwidth,scale)
	love.graphics.print("pause: R continue   esc main menu",2*scale,screenheight-22*scale,0,scale)
	love.graphics.print("r restart the level volume "..(volume>0 and "<" or "[")..string.rep("-",volume)..string.rep(" ",10-volume)..(volume<10 and ">" or "]"),2*scale,screenheight-10*scale,0,scale)
end
function pause_keypressed(key)
	if key=="escape" then
		menu_load(true)
		love.audio.stop()
	elseif key=="return" then
		gamestate=pausedgamestate
		lockmouse()
		love.audio.resume()
	elseif key=="r" then
		gamestate=pausedgamestate
		lockmouse()
		love.audio.resume()
		if gamestate=="custom" then
			_G[gamestate.."_load"](origlevel,editorMode)
		else
			_G[gamestate.."_load"]()
		end
		gamestatemovetimer=0
	elseif key=="left" then
		if volume > 0 then
			volume = volume - 1
			love.audio.setVolume(volume/10)
			local sound = _G["wakka" .. math.mod(volume, 2)+1]
			sound:stop()
			sound:play()
			savehighscoresA()
		end
	elseif key=="right" then
		if volume < 10 then
			volume = volume + 1
			love.audio.setVolume(volume/10)
			local sound = _G["wakka" .. math.mod(volume, 2)+1]
			sound:stop()
			sound:play()
			savehighscoresA()
		end
	end
end